
local map_udlr = {
map = {
{1,0,1},
{0,0,0},
{1,0,1}
},
dirn = {"u","d","l","r"},
id = "ulrd"
}
local map_lr = {
map = {
{1,1,1},
{0,0,0},
{1,1,1}
},
dirn = {"l","r"},
id = "lr"
}
local map_ud = {
map = {
{1,0,1},
{1,0,1},
{1,0,1}
},
dirn = {"u","d"},
id = "ud"
}
local map_ld = {
map = {
{1,1,1},
{0,0,1},
{1,0,1}
},
dirn = {"l","d"},
id = "ld"
}
local map_rd = {
map = {
{1,1,1},
{1,0,0},
{1,0,1}
},
dirn = {"d","r"},
id = "dr"
}
local map_lu = {
map = {
{1,0,1},
{0,0,1},
{1,1,1}
},
dirn = {"l","u"},
id = "lu"
}
local map_ru = {
map = {
{1,0,1},
{1,0,0},
{1,1,1}
},
dirn = {"u","r"},
id = "ur"
}
local map_lur = {
map = {
{1,0,1},
{0,0,0},
{1,1,1}
},
dirn = {"l","u","r"},
id = "lur"
}
local map_urd = {
map = {
{1,0,1},
{1,0,0},
{1,0,1}
},
dirn = {"u","r","d"},
id = "urd"
}
local map_ldr = {
map = {
{1,1,1},
{0,0,0},
{1,0,1}
},
dirn = {"l","d","r"},
id = "ldr"
}
local map_uld = {
map = {
{1,0,1},
{0,0,1},
{1,0,1}
},
dirn = {"u","l","d"},
id = "uld"
}

local valid = {}
valid.u = {map_uld,map_ldr,map_urd,map_ld,map_rd,map_ud,map_udlr}
valid.d = {map_uld,map_lur,map_urd,map_lu,map_ru,map_ud,map_udlr}
valid.l = {map_urd,map_ldr,map_urd,map_rd,map_ru,map_lr,map_udlr}
valid.r = {map_uld,map_lur,map_uld,map_ld,map_lu,map_lr,map_udlr}

local dirtab = {u = {0,-3}, d = {0,3}, l = {-3,0}, r = {3,0}}

local puzlemap = {}

local puzlecloselst = {}

local tilemap = {}

local randomcount = 0

local blank = 0


function randomize()

randomcount = randomcount + 1

puzlemap = {}

puzlecloselst = {}

tilemap = {}

for i=1,25 do
	puzlemap[i]={}
	for j=1,25 do 
		puzlemap[i][j] = 0
	end
end

for i=1,(25*3+2) do
	tilemap[i]={}
	for j=1,(25*3+2) do 
		--if i == 1 or j == 1 or i == (25*3+2) or j == (25*3+2) then
			tilemap[i][j] = 1
		--else
			--tilemap[i][j] = 0
		--end
	end
end

math.randomseed(love.timer.getMicroTime()*1000)
math.random()
math.random()

puzlemap[13][13] = "ulrd"
for i=-1,1 do
	for j=-1,1 do 
		tilemap[13*3+i][13*3+j] = map_udlr.map[i+2][j+2]
	end
end
puzlecloselst[(13-1)*25+13] = true 

local opentab = {}
for i,dir in pairs(map_udlr.dirn) do
	opentab[i] = {}
	opentab[i].x = 13+((dirtab[dir][1])/3)
	opentab[i].y = 13+((dirtab[dir][2])/3)
	opentab[i].dir = dir
end

while #opentab  > 0 do
--for a=1,50 do
	local tempopen = {}
	for b=1,#opentab do
		if puzlemap[opentab[b].x] and puzlemap[opentab[b].x][opentab[b].y] and not puzlecloselst[(opentab[b].x-1)*25+opentab[b].y] then
 			local rand = math.random(1,#valid[opentab[b].dir])
			puzlemap[opentab[b].x][opentab[b].y] = valid[opentab[b].dir][rand].id
			--debug = opentab[b].dir
			--debug = valid[opentab[b].dir][rand].id
			--do break end
			for i=-1,1 do
				for j=-1,1 do 
					tilemap[opentab[b].y*3+i][opentab[b].x*3+j] = valid[opentab[b].dir][rand].map[i+2][j+2]
				end
			end
			puzlecloselst[(opentab[b].x-1)*25+opentab[b].y] = true

			for lop,dir in pairs(valid[opentab[b].dir][rand].dirn) do
				local tab = {}
				tab.x = opentab[b].x+((dirtab[dir][1])/3)
				tab.y = opentab[b].y+((dirtab[dir][2])/3)
				tab.dir = dir
				table.insert(tempopen,#tempopen+1,tab)
			end
		end
	end
	opentab = {}
	for i,tab in pairs(tempopen) do
		opentab[i]=tab
	end
end
blank = 0
for y=1, #puzlemap do
	for x=1, #puzlemap[y] do
			
		if puzlemap[y][x] == 0 then
			blank = blank + 1
		end
			
	end
end
if blank > 62 then
	return randomize()
end

end

function love.update(dt)


end

function love.draw()
	
	love.graphics.setColor(255,255,255)
   	--love.graphics.print(tostring(debug),20,20)
  	 for y=1, #tilemap do
		for x=1, #tilemap[y] do
			
			if tilemap[y][x] == 1 then
				love.graphics.setColor(255,255,255)
				love.graphics.rectangle("fill", x * 8, y * 8, 8, 8)
			--[[else
				love.graphics.setColor(0,0,255)
				love.graphics.rectangle("line", x * 8, y * 8, 8, 8)]]
			end	
           		
		 end
        end
   	love.graphics.setColor(0,255,255)
	love.graphics.print(randomcount.."      "..blank,20,20)
	--[[for y=1, #puzlemap do
		for x=1, #puzlemap[y] do
			
			love.graphics.print(tostring(puzlemap[x][y]), x * 20, y * 20)
			
		 end
        end]]

end



function love.keypressed(key)
	if key == " " then randomize() end
end

randomize()